ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.1 by root, Mon Dec 6 19:33:58 2010 UTC vs.
Revision 1.33 by root, Thu Feb 24 07:10:03 2011 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6PERLVER=5.12.2 # 5.8.9 is also a good choice
7STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
8CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
9EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
10 9
11MKBUNDLE="$STATICPERL/mkbundle"
12
13# perl build variables 10# perl build variables
14PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
15PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
28 ;; 28 ;;
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 36
37# some configuration options for modules 37# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
41 42
42# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
43# required by mkbundle 44# required by mkbundle
44EXTRA_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46
47# which extra modules you might want to install
48EXTRA_MODULES=""
45 49
46# overridable functions 50# overridable functions
51preconfigure() { : ; }
47postconfigure() { : ; } 52postconfigure() { : ; }
48postbuild() { : ; } 53postbuild() { : ; }
49postinstall() { : ; } 54postinstall() { : ; }
50 55
51# now source user config, if any 56# now source user config, if any
57if [ "$STATICPERLRC" ]; then
58 . "$STATICPERLRC"
59else
52[ -r /etc/staticperlrc ] && . /etc/staticperlrc 60 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
53[ -r ~/.staticperlrc ] && . ~/.staticperlrc 61 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
54[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 62 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
63fi
55 64
56############################################################################# 65#############################################################################
57# support 66# support
67
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
72LC_ALL=C; export LC_ALL # just to be on the safe side
58 73
59# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
60VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
61$VERSION=0.1 76$VERSION="1.1"
62 77
63BZ2=bz2 78BZ2=bz2
64BZIP2=bzip2 79BZIP2=bzip2
65 80
66fatal() { 81fatal() {
99############################################################################# 114#############################################################################
100# clean 115# clean
101 116
102distclean() { 117distclean() {
103 verblock <<EOF 118 verblock <<EOF
104deleting everything installed by this script 119 deleting everything installed by this script (rm -rf $STATICPERL)
105EOF 120EOF
106 121
107 rm -rf "$STATICPERL" 122 rm -rf "$STATICPERL"
108} 123}
109 124
110############################################################################# 125#############################################################################
111# download/configure/compile/install perl 126# download/configure/compile/install perl
112 127
113clean() { 128clean() {
114 cd "$STATICPERL/src/perl-$PERLVER" 2>/dev/null || return 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
130}
115 131
116 rm -f staticstamp.configure 132realclean() {
117 make distclean >/dev/null 2>&1 133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
118} 136}
119 137
120fetch() { 138fetch() {
121 rcd "$STATICPERL" 139 rcd "$STATICPERL"
122 140
123 mkdir -p src 141 mkdir -p src
124 rcd src 142 rcd src
125 143
126 if ! [ -d "perl-$PERLVER" ]; then 144 if ! [ -d "perl-$PERL_VERSION" ]; then
127 if ! [ -e "perl-$PERLVER.tar.$BZ2" ]; then 145 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then
128 146
129 URL="$CPAN/src/5.0/perl-$PERLVER.tar.$BZ2" 147 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2"
130 148
131 verblock <<EOF 149 verblock <<EOF
132downloading perl 150downloading perl
133to manually download perl yourself, place 151to manually download perl yourself, place
134perl-$PERLVER.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
135trying $URL 153trying $URL
136EOF 154EOF
137 155
156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
138 curl >perl-$PERLVER.tar.$BZ2~ "$URL" \ 157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
139 || wget -O perl-$PERLVER.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
140 || fatal "$URL: error during downloading" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
141 mv perl-$PERLVER.tar.$BZ2~ perl-$PERLVER.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
142 fi 162 fi
143 163
144 verblock <<EOF 164 verblock <<EOF
145unpacking perl 165unpacking perl
146EOF 166EOF
147 167
148 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
149 $BZIP2 -d <perl-$PERLVER.tar.bz2 | tar xpC unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | tar xfC - unpack \
150 || fatal "perl-$PERLVER.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
172 chmod -R u+w unpack/perl-$PERL_VERSION
151 mv unpack/perl-$PERLVER perl-$PERLVER 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
152 rmdir -p unpack 174 rmdir -p unpack
153 fi 175 fi
154} 176}
155 177
156# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
157sedreplace() { 179sedreplace() {
158 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
159 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
160} 209}
161 210
162configure() { 211configure() {
163 fetch 212 fetch
164 213
165 rcd "$STATICPERL/src/perl-$PERLVER" 214 rcd "$STATICPERL/src/perl-$PERL_VERSION"
166 215
167 [ -e staticstamp.configure ] && return 216 [ -e staticstamp.configure ] && return
168 217
169 verblock <<EOF 218 verblock <<EOF
170configuring $STATICPERL/src/perl-$PERLVER 219configuring $STATICPERL/src/perl-$PERL_VERSION
171EOF 220EOF
172 221
173 clean
174
175 rm -f "$PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
176 223
224 "$MAKE" distclean >/dev/null 2>&1
225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
177 # I hate them 228 # I hate them for this
178 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
179 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
231
232 preconfigure
180 233
181# trace configure \ 234# trace configure \
182 sh Configure -Duselargefiles \ 235 sh Configure -Duselargefiles \
183 -Uuse64bitint \ 236 -Uuse64bitint \
184 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
185 -Uusedl \ 238 -Uusedl \
186 -Uusethreads \ 239 -Uusethreads \
187 -Uuseithreads \ 240 -Uuseithreads \
188 -Uusemultiplicity \ 241 -Uusemultiplicity \
189 -Duseperlio \
190 -Uusesfio \ 242 -Uusesfio \
191 -Uuseshrplib \ 243 -Uuseshrplib \
244 -Uinstallusrbinperl \
192 -Dcppflags="$PERL_CPPFLAGS" \ 245 -A ccflags=" $PERL_CCFLAGS" \
193 -Dccflags="-g2 -fno-strict-aliasing" \ 246 -Dcc="$PERL_CC" \
194 -Doptimize="$PERL_OPTIMIZE" \ 247 -Doptimize="$PERL_OPTIMIZE" \
195 -Dldflags="$PERL_LDFLAGS" \ 248 -Dldflags="$PERL_LDFLAGS" \
196 -Dlibs="$PERL_LIBS" \ 249 -Dlibs="$PERL_LIBS" \
197 -Dprefix="$PREFIX" \ 250 -Dprefix="$PERL_PREFIX" \
198 -Dbin="$PREFIX/bin" \ 251 -Dbin="$PERL_PREFIX/bin" \
199 -Dprivlib="$PREFIX/plib" \ 252 -Dprivlib="$PERL_PREFIX/lib" \
200 -Darchlib="$PREFIX/plib" \ 253 -Darchlib="$PERL_PREFIX/lib" \
201 -Uusevendorprefix \ 254 -Uusevendorprefix \
202 -Dsitelib="$PREFIX/plib" \ 255 -Dsitelib="$PERL_PREFIX/lib" \
203 -Dsitearch="$PREFIX/plib" \ 256 -Dsitearch="$PERL_PREFIX/lib" \
204 -Usitelibexp \
205 -Uman1dir \ 257 -Uman1dir \
206 -Uman3dir \ 258 -Uman3dir \
207 -Usiteman1dir \ 259 -Usiteman1dir \
208 -Usiteman3dir \ 260 -Usiteman3dir \
209 -Dpager=/usr/bin/less \ 261 -Dpager=/usr/bin/less \
210 -Demail="$EMAIL" \ 262 -Demail="$EMAIL" \
211 -Dcf_email="$EMAIL" \ 263 -Dcf_email="$EMAIL" \
212 -Dcf_by="$EMAIL" \ 264 -Dcf_by="$EMAIL" \
265 $PERL_CONFIGURE \
266 -Duseperlio \
213 -dE || fatal "Configure failed" 267 -dE || configure_failure
214 268
215 sedreplace ' 269 sedreplace '
216 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 270 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
217 s/ *-fno-stack-protector */ /g 271 s/ *-fno-stack-protector */ /g
218 ' config.sh 272 ' config.sh
225} 279}
226 280
227build() { 281build() {
228 configure 282 configure
229 283
230 rcd "$STATICPERL/src/perl-$PERLVER" 284 rcd "$STATICPERL/src/perl-$PERL_VERSION"
231 285
232 verblock <<EOF 286 verblock <<EOF
233building $STATICPERL/src/perl-$PERLVER 287building $STATICPERL/src/perl-$PERL_VERSION
234EOF 288EOF
235 289
236 rm -f "$PREFIX/staticstamp.install" 290 rm -f "$PERL_PREFIX/staticstamp.install"
237 291
238 make || fatal "make: error while building perl" 292 "$MAKE" || fatal "make: error while building perl"
239 293
240 postbuild || fatal "postbuild hook failed" 294 postbuild || fatal "postbuild hook failed"
241} 295}
242 296
243install() { 297install() {
244 [ -e "$PREFIX/staticstamp.install" ] && return 298 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
245
246 build 299 build
247 300
248 verblock <<EOF 301 verblock <<EOF
249installing $STATICPERL/src/perl-$PERLVER 302installing $STATICPERL/src/perl-$PERL_VERSION
250to $PREFIX 303to $PERL_PREFIX
251EOF 304EOF
252 305
253 rm -rf "$PREFIX" 306 ln -sf "perl/bin/" "$STATICPERL/bin"
254 307 ln -sf "perl/lib/" "$STATICPERL/lib"
308
309 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
310 rm -rf "$PERL_PREFIX" # by this rm -rf
311
255 make install || fatal "make install: error while installing" 312 "$MAKE" install || fatal "make install: error while installing"
256 313
314 rcd "$PERL_PREFIX"
315
257 # create a "make install" replacement for CPAN 316 # create a "make install" replacement for CPAN
258 cat >"$PREFIX"/bin/cpan-make-install <<EOF 317 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
259make install UNINST=1 318"$MAKE" || exit
319
260if find blib/arch/auto -type f | grep -q -v .exists; then 320if find blib/arch/auto -type f | grep -q -v .exists; then
261 echo Probably an XS module, rebuilding perl 321 echo Probably an XS module, rebuilding perl
262 make perl 322 if "$MAKE" perl; then
323 mv perl "$PERL_PREFIX"/bin/perl~ \
263 rm -f "$PREFIX"/bin/perl 324 && rm -f "$PERL_PREFIX"/bin/perl \
264 make -f Makefile.aperl inst_perl 325 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
265 make -f Makefile.aperl map_clean 326 "$MAKE" -f Makefile.aperl map_clean
327 else
328 "$MAKE" -f Makefile.aperl map_clean
329 exit 1
330 fi
266fi 331fi
332
333"$MAKE" install UNINST=1
267EOF 334EOF
268 chmod 755 "$PREFIX"/bin/cpan-make-install 335 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
269 336
337 # trick CPAN into avoiding ~/.cpan completely
338 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
339
270 "$PREFIX"/bin/perl -MCPAN -e ' 340 "$PERL_PREFIX"/bin/perl -MCPAN -e '
271 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 341 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
272 CPAN::Shell->o (conf => q<init>);
273 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
343 CPAN::Shell->o (conf => q<init>);
344 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
274 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 345 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
275 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 346 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
276 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 347 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
277 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 348 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
278 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PREFIX"'/bin/cpan-make-install"); 349 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
279 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 350 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
280 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 351 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
281 CPAN::Shell->o (conf => q<commit>); 352 CPAN::Shell->o (conf => q<commit>);
282 ' || fatal "error while initialising CPAN" 353 ' || fatal "error while initialising CPAN"
283 354
355 touch "$PERL_PREFIX/staticstamp.install"
356 fi
357
358 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
284 NOCHECK_INSTALL=+ 359 NOCHECK_INSTALL=+
285 instcpan $EXTRA_MODULES 360 instcpan $STATICPERL_MODULES
361 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
286 362
287 postinstall || fatal "postinstall hook failed" 363 postinstall || fatal "postinstall hook failed"
288 364
289 touch "$PREFIX/staticstamp.install" 365 touch "$PERL_PREFIX/staticstamp.postinstall"
366 fi
290} 367}
291 368
292############################################################################# 369#############################################################################
293# install a module from CPAN 370# install a module from CPAN
294 371
299installing modules from CPAN 376installing modules from CPAN
300$@ 377$@
301EOF 378EOF
302 379
303 for mod in "$@"; do 380 for mod in "$@"; do
304 "$PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 381 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \
305 || fatal "$mod: unable to install from CPAN" 382 || fatal "$mod: unable to install from CPAN"
306 done 383 done
307 rm -rf "$STATICPERL/build" 384 rm -rf "$STATICPERL/build"
308} 385}
309 386
321 for mod in "$@"; do 398 for mod in "$@"; do
322 echo 399 echo
323 echo $mod 400 echo $mod
324 ( 401 (
325 rcd $mod 402 rcd $mod
326 make -f Makefile.aperl map_clean >/dev/null 2>&1 403 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
327 make distclean >/dev/null 2>&1 404 "$MAKE" distclean >/dev/null 2>&1
328 "$PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 405 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
329 make || fatal "$mod: error building module" 406 "$MAKE" || fatal "$mod: error building module"
330 "$PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 407 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
331 make distclean >/dev/null 2>&1 408 "$MAKE" distclean >/dev/null 2>&1
332 exit 0 409 exit 0
333 ) || exit $? 410 ) || exit $?
334 done 411 done
335} 412}
336 413
337############################################################################# 414#############################################################################
338# do schmorpy stuff
339
340MODSRCDIR=~/src
341
342instmodsrc() {
343 for mod in "$@"; do
344 instmod_src "$MODSRCDIR/$mod"
345 done
346}
347
348install_schmorp() {
349 install
350
351 instcpan Data::Dump Term::ReadLine::Perl Term::ANSIColor Term::ReadKey
352 instcpan Digest::SHA Digest::MD6 Digest::SHA256 Digest::MD4 Digest::HMAC_MD5 Digest::HMAC_MD6 Digest::FNV
353 #instcpan Net::SSLeay # requires static -ldl
354
355 instmodsrc common-sense Crypt-Twofish2 Array-Heap Convert-Scalar Compress-LZF JSON-XS
356 instmodsrc EV Guard Async-Interrupt IO-AIO
357 instmodsrc AnyEvent AnyEvent-AIO Coro AnyEvent-HTTP
358 instmodsrc Linux-Inotify2 EV-Loop-Async
359
360 instcpan AnyEvent::HTTPD
361}
362
363#############################################################################
364# main 415# main
365 416
366podusage() { 417podusage() {
367 echo 418 echo
419
368 if [ -e "$PREFIX/bin/perl" ]; then 420 if [ -e "$PERL_PREFIX/bin/perl" ]; then
369 "$PREFIX/bin/perl" -MPod::Usage -e \ 421 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
370 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 422 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
371 2>/dev/null && exit 423 2>/dev/null && exit
372 fi 424 fi
425
373 # try whatever perl we can find 426 # try whatever perl we can find
374 perl -MPod::Usage -e \ 427 perl -MPod::Usage -e \
375 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 428 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
376 2>/dev/null && exit 429 2>/dev/null && exit
377 430
378 fatal "displaying documentation requires a working perl - try '$0 install' first" 431 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
379} 432}
380 433
381usage() { 434usage() {
382 podusage 0 435 podusage 0
383} 436}
384 437
385catmkbundle() { 438catmkbundle() {
386 { 439 {
387 read dummy 440 read dummy
388 echo "#!$PREFIX/bin/perl" 441 echo "#!$PERL_PREFIX/bin/perl"
389 cat 442 cat
390 } <<'MKBUNDLE' 443 } <<'MKBUNDLE'
391#CAT mkbundle 444#CAT mkbundle
392MKBUNDLE 445MKBUNDLE
393} 446}
394 447
395bundle() { 448bundle() {
396 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 449 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
397 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 450 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
451 CACHE="$STATICPERL/cache"
452 mkdir -p "$CACHE"
398 "$PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 453 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
399} 454}
400 455
401if [ $# -gt 0 ]; then 456if [ $# -gt 0 ]; then
402 while [ $# -gt 0 ]; do 457 while [ $# -gt 0 ]; do
403 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 458 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
404 mkdir -p "$PREFIX" || fatal "$PREFIX: cannot create" 459 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
405 460
406 command="${1#--}"; shift 461 command="${1#--}"; shift
407 case "$command" in 462 case "$command" in
463 version )
464 echo "staticperl version $VERSION"
465 ;;
408 fetch | configure | build | install | clean | distclean) 466 fetch | configure | build | install | clean | realclean | distclean)
409 verblock <<EOF
410$command
411EOF
412 "$command" 467 ( "$command" ) || exit
413 ;; 468 ;;
414 instsrc ) 469 instsrc )
415 instsrc "$@" 470 ( instsrc "$@" ) || exit
416 exit 471 exit
417 ;; 472 ;;
418 instcpan ) 473 instcpan )
419 instcpan "$@" 474 ( instcpan "$@" ) || exit
420 exit 475 exit
421 ;; 476 ;;
422 instschmorp )
423 install_schmorp
424 ;;
425 cpan ) 477 cpan )
426 install 478 ( install ) || exit
427 "$PREFIX/bin/cpan" "$@" 479 "$PERL_PREFIX/bin/cpan" "$@"
428 exit 480 exit
429 ;; 481 ;;
430 mkbundle ) 482 mkbundle )
431 install 483 ( install ) || exit
432 bundle "$@" 484 bundle "$@"
433 exit 485 exit
434 ;; 486 ;;
435 mkperl ) 487 mkperl )
436 install 488 ( install ) || exit
437 bundle --perl "$@" 489 bundle --perl "$@"
490 exit
491 ;;
492 mkapp )
493 ( install ) || exit
494 bundle --app "$@"
438 exit 495 exit
439 ;; 496 ;;
440 help ) 497 help )
441 podusage 2 498 podusage 2
442 ;; 499 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines